GroupAssignmentTwo/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings

# import homepage.views as views
from register import views as v
from django.contrib.auth import views as auth_views
from django.conf.urls.static import static

urlpatterns = [
    path('admin/', admin.site.urls),
    # path('login/', auth_views.LoginView.as_view(template_name='login.html'), name='login'),
    # path('logout/', auth_views.LogoutView.as_view(), name='logout'),
    # path('signup/', views.signup, name='signup'),
    # path('settings/password/', views.settings, name='settings'),
    # path('oauth/', include('social_django.paths', namespace='social')),

    # path('register/', v.register, name='register'),
    # path('profile/', v.profile, name='profile'),
    # path('login/', auth_views.LoginView.as_view(template_name='register/login.html'), name='login'),
    # path('logout/', auth_views.LogoutView.as_view(template_name='register/logout.html'), name='logout'),

#    path('password-reset/',
#         auth_views.PasswordResetView.as_view(template_name='register/password_reset.html'),
#         name='password_reset'),

#     path('password-reset/done/',
#         auth_views.PasswordResetDoneView.as_view(template_name='register/password_reset_done.html'),
#         name='password_reset_done'),
    
#     path('password-reset-confirm/<uidb64>/<token>',
#         auth_views.PasswordResetConfirmView.as_view(template_name='register/password_reset_confirm.html'),
#         name='password_reset_confirm'),
    
#     path('password-reset-complete/',
#         auth_views.PasswordResetCompleteView.as_view(template_name='register/password_reset_complete.html'),
#         name='password_reset_complete'),
    path('',include('homepage.urls')),
    path('cart/', include('cart.urls')),
    path('product/', include('products.urls')),
    path('buy/', include('transaction.urls')),
    path('register/', v.register, name='register'),
    path('profile/', v.profile, name='profile'),
    path('review/', include('review.urls')),
    path('login/', auth_views.LoginView.as_view(template_name='register/login.html'), name='login'),
    path('logout/', auth_views.LogoutView.as_view(template_name='register/logout.html'), name='logout'),

    #Password Reset
    path('password-reset/',
        auth_views.PasswordResetView.as_view(template_name='register/password_reset.html'),
        name='password_reset'),

    path('password-reset/done/',
        auth_views.PasswordResetDoneView.as_view(template_name='register/password_reset_done.html'),
        name='password_reset_done'),
    
    path('password-reset-confirm/<uidb64>/<token>',
        auth_views.PasswordResetConfirmView.as_view(template_name='register/password_reset_confirm.html'),
        name="password_reset_confirm"),
    
    path('password-reset-complete/',
        auth_views.PasswordResetCompleteView.as_view(template_name='register/password_reset_complete.html'),
        name='password_reset_complete'),
    
    #Google Login
    path('accounts/', include('allauth.urls')),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

cart/urls.py
from django.urls import path, include
from . import views

app_name = 'ShoppingCart'

urlpatterns = [
    path('', views.CartView),
    path('json/', views.Json_Response),
]

transaction/urls.py
from django.urls import path, include
from django.conf.urls import url
from . import views

app_name = 'transaction'

urlpatterns = [
    path('', views.index, name='index'),
    path('API/getcoupons', views.getcoupon, name='getcoupon'),
    path('API/pay', views.pay, name='pay')
]

cart/models.py
from django.db import models
from register.models import Profile
from products.models import Product
# Create your models here.
class OrderItem(models.Model):
    owner = models.ForeignKey(Profile, on_delete=models.SET_NULL, null=True)
    product = models.OneToOneField(Product, on_delete=models.SET_NULL, null=True)
    ammount = models.PositiveIntegerField(default=1)
    date_added = models.DateTimeField(auto_now=True)
    

    def __str__(self):
        return self.product.name

class Order(models.Model):
    ref_code = models.CharField(max_length=15)
    owner = models.ForeignKey(Profile, on_delete=models.SET_NULL, null=True)
    items = models.ManyToManyField(OrderItem)
    

    def get_cart_items(self):
        return self.items.all()

    def get_cart_total(self):
        return sum([item.product.price for item in self.items.all()])

    def __str__(self):
        return '{0} - {1}'.format(self.owner, self.ref_code)

cart/views.py
from django.shortcuts import render, get_object_or_404
from django.http import HttpResponse
import json
from .models import Order, OrderItem
from django.core.serializers.json import DjangoJSONEncoder
from django.core.serializers import serialize
from django.views.decorators.csrf import csrf_exempt
from cart.models import Order,OrderItem
from register.models import Profile
from products.models import Product
import random
import string
from datetime import date
import datetime

# Create your views here.

def generate_order_id():
    date_str = date.today().strftime('%Y%m%d')[2:] + str(datetime.datetime.now().second)
    rand_str = "".join([random.choice(string.digits) for count in range(3)])
    return date_str + rand_str


@csrf_exempt
def CartView(request):
    if request.method == "POST":
        if request.POST["task"] == "del":    
            cart_item = request.POST['cart_item']
            item_to_delete = OrderItem.objects.filter(id=cart_item)
            print(item_to_delete)
            if item_to_delete.exists():
                item_to_delete[0].delete()

        else:  
            item_id = request.POST["data"]
            user_profile = get_object_or_404(Profile, user=request.user)
            product = Product.objects.filter(id=item_id).first()
            order_item, status= OrderItem.objects.get_or_create(product=product, owner=user_profile)
            user_order, status = Order.objects.get_or_create(owner=user_profile)
            user_order.items.add(order_item)
            user_order.ref_code = generate_order_id()
            user_order.save()


        # item_name = request.POST["cart_item"]
        # cart_item = CartModel.objects.get(name = item_name)
        # if request.POST['task'] == "del":
        #     print("remove item")
        #     # cart_item.delete()
        # else:
        #     if cart_item.stock > 1:
        #         print("reduce it")
        #         # cart_item.stock -= 1
        #         # cart_item.save()
        #     else:
        #         # cart_item.delete()
        #         print("remove item")
    
    return render(request, 'cart/cart.html')

def Json_Response(request):
    user_profile = Profile.objects.get(user=request.user)
    user_order = Order.objects.get(owner=user_profile)
    data = []
    for i in range (user_order.items.all().count()):
        data.append({
            'name': user_order.items.all()[i].product.name, 
            'price' : user_order.items.all()[i].product.price,
            'item_id' : user_order.items.all()[i].product.id,
            'stock': user_order.items.all()[i].product.stock,
            'Order_refcode': user_order.ref_code
            })
    # try:
    #     total_price=0
    #     total_item_bought = CartModel.objects.all().count()
    #     for i in range(total_item_bought):
    #         stock = CartModel.objects.all()[i].stock
    #         price = CartModel.objects.all()[i].price
    #         total_price += stock * price   

    #     response_data = {
    #         'total_price' : total_price
    #     }

    # except:
    #     response_data = {
    #         'total_price' : 0
    #     }

    # data = serialize('json', CartModel.objects.all())

    # json_resp = {
    #     'data' : data,
    #     'total' : response_data
    # }
    return HttpResponse(json.dumps(data), content_type="application/json")

cart/templates/cart/ammount.html
{% load static %}

<script>
    $("html").on('click', '.addammount', function(e) {
        e.preventDefault()

        var item = $(this).closest("tr")
        var totalpricetext = $(this).closest(".table").find(".totalprice")

        var ammountext = $(item).find(".ammount")
        var ammount = parseInt($(ammountext).text(), 10)

        var stock = parseInt($(item).find(".stock").text(), 10)
        var price = parseInt($(item).find(".price").text(), 10)
        var totalprice = parseInt($(totalpricetext).text(), 10)

        if(ammount < stock) {
            ammount += 1
            $(item).find(".total").text((price*ammount).toString(10))

            totalprice += price
            $(totalpricetext).text(totalprice.toString(10))
        }

        $(ammountext).text(ammount.toString(10))
    })

    $("html").on('click', '.decammount', function(e) {
        e.preventDefault()
        var item = $(this).closest("tr")
        var totalpricetext = $(this).closest(".table").find(".totalprice")

        var ammountext = $(item).find(".ammount")
        var ammount = parseInt($(ammountext).text(), 10)
        var price = parseInt($(item).find(".price").text(), 10)
        var totalprice = parseInt($(totalpricetext).text(), 10)

        if(ammount > 1) {
            ammount -= 1
            $(item).find(".total").text((price*ammount).toString(10))

            totalprice -= price
            $(totalpricetext).text(totalprice.toString(10))
        }

        $(ammountext).text(ammount.toString(10))
    })
</script>

cart/templates/cart/base.html
<!doctype html>
{% load static %}
<html lang="en">

  <head>

    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css" integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">
    
    <!-- Home CSS -->
    <link rel="stylesheet" href="{% static 'cart/style.css' %}">

    <!-- Font Link -->
    <link href="https://fonts.googleapis.com/css?family=Oswald|Playfair+Display&display=swap" rel="stylesheet">


    <title>stackovershoes</title>

  </head>
  
  <body>

    <nav class="navbar navbar-expand-lg navbar-dark bg-dark sticky-top">
      <div class="container">
        <a class="navbar-brand" href="/">
          <img src="{% static 'homepage/stackovershoes-logo-white.png' %}" width="40" height="40" alt="">
        </a>
        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarTogglerDemo02" aria-controls="navbarTogglerDemo02" aria-expanded="false" aria-label="Toggle navigation">
          <span class="navbar-toggler-icon"></span>
        </button>
        <form class="form-inline my-2 my-lg-0">
          <input class="form-control mr-sm-2 nav-font" type="search" placeholder="Search">
        </form>
        <div class="collapse navbar-collapse" id="navbarTogglerDemo02">
          <ul class="navbar-nav ml-auto">
            <li class="nav-item active">
              <a class="nav-link nav-font" href="#"><b>CATEGORY</b></a>
            </li>

            {% if user.is_authenticated %}
            <li class="nav-item active">
              <a class="nav-link nav-font" href="/product"><b>CART</b></a>
            </li>
            <li class="nav-item active">
              <a class="nav-link nav-font" href="#"><b>HISTORY</b></a>
            </li>
            <li class="nav-item active dropdown">
                <a class="nav-link dropdown-toggle nav-font" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" style="text-transform: uppercase;">
                  {{ user.username }}
                </a>
                <div class="dropdown-menu" aria-labelledby="navbarDropdown">
                  <a class="dropdown-item" href="/profile">PROFILE</a>
                  <div class="dropdown-divider"></div>
                  <a class="dropdown-item" href="/logout">LOGOUT</a>
                </div>
              </li>

            {% else %}
            <li class="nav-item active">
                <a class="nav-link nav-font" href="/login"><b>SIGN IN</b></a> 
              </li>
              <li class="nav-item active">
                <a class="nav-link nav-font" href="/register"><b>REGISTER</b></a>
              </li>
            {% endif %}
          </ul>  
        </div>
      </div>
    </nav>

    {% if messages %}
      {% for message in messages %}
        <div class="alert alert-{{ message.tags}}">
          {{ message }}
        </div>
      {% endfor %}
    {% endif %}

{% block content %}{% endblock %}

    <!-- Optional JavaScript -->
    <!-- jQuery first, then Popper.js, then Bootstrap JS -->
    <!-- <script src="https://code.jquery.com/jquery-3.4.1.slim.min.js" integrity="sha384-J6qa4849blE2+poT4WnyKhv5vZF5SrPo0iEjwBvKU7imGFAV0wwj1yYfoRSJoZ+n" crossorigin="anonymous"></script> -->
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js" integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js" integrity="sha384-wfSDF2E50Y2D1uUdj0O3uMBJnjuUD4Ih7YwaYd1iqfktj0Uod8GCExl3Og8ifwB6" crossorigin="anonymous"></script>

</html>

cart/templates/cart/cart.html
{% extends "cart/base.html" %}
    {% load static %}
        {% block content %}

        <div class="container text-center" style="margin-top:20px;">
            <div class="col">
                <table id="place" class="table"></table>
            </div>

            <script src="{% static 'jquery.js' %}"></script>
            <script>
                var ourData 
                var buttons
                var total
                var total_btn
                var Order_refcode



                window.onload = function(){
                    place = document.getElementById("place");
                }

                $.get("/cart/json/", function(json_response){
                        console.log(json_response)
                        ourData = json_response
                        Order_refcode = ourData.Order_refcode
                        renderHTML(ourData)
                        delButtonMap("del")
                    })

                function totalMap(buttonName){
                    total_btn = document.getElementById(buttonName)

                }

                function delButtonMap(buttonName){
                    buttons = document.getElementsByName(buttonName)
                    for(i = 0; i < buttons.length; i++){
                        buttons[i].onclick = function(e){
                            $.ajax({
                                url : '/cart/',
                                data : {
                                    task : "del",
                                    cart_item : this.id
                                    },
                                type: 'POST',
                                success : function(){

                                    $.get("/cart/json/", function(json_response){
                                        console.log(json_response)
                                        ourData = json_response
                                        renderHTML(ourData)
                                        delButtonMap("del")
                                    })
                                    alert("Remove Successful")
                                    }
                                })
                        }
                    }
                }

                function renderHTML(data) {
                    var total = 0
                    var table="<thead class='thead-dark'><tr><th>Name</th><th>Price</th><th>Amount</th><th>Actions</th><th>Total</th></tr></thead><tbody>";
                        for (i = 0; i < data.length; i++) {
                            const name = data[i].name
                            const price = data[i].price
                            const id = data[i].item_id
                            const stock = data[i].stock
                            total += price

                            table += "<tr><td>" + 
                            name  + "</td><td class='price'>"+
                            price + "</td>"
                            + `
                            <td>
                                <span class="ammount">1</span>/<span class="stock">${stock}</span>
                            </td>
                            <td>
                            <form class="decammount">
                                <svg type="submit" class="button-dec" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="black" width="24px" height="24px"><path d="M19 13H5v-2h14v2z"/><path d="M0 0h24v24H0z" fill="none"/></svg>
                            </form>
                            <form class="addammount">
                                <svg type="submit" class="button-add" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="black" width="24px" height="24px"><path d="M19 13h-6v6h-2v-6H5v-2h6V5h2v6h6v2z"/><path d="M0 0h24v24H0z" fill="none"/></svg>
                            </form>
                            `
                            + "<button class='btn btn-dark' name='del' id='"+ id +"'>Remove</button></td>"
                            +"<td class='total'>"+ price + "</td>"
                            +"</tr>";
                        }
                    table += "</tbody><tfoot>"+ 
                    "<tr class='visible-xs'>"+
                            "<td><button href='#' class='btn btn-dark' style='float : left;'>Continue Shopping</button></td>"+
							"<td colspan='2' class='hidden-xs'></td>"+
							`<td class='hidden-xs text-center total'><strong>Total <span class="totalprice">${total}</span></strong><button href='{% url 'transaction:index' %}?ref_code=${Order_refcode}' class='btn btn-dark ml-2' id='total_btn'>Checkout</button></td></tr>`+
					"</tfoot>" 
                    place.innerHTML = table;
                    }
            </script>
            {% include 'cart/ammount.html' %}
        {% endblock %}